#' @title Differentially Methylated CpG using Hidden Markov Model
#'
#' @description DMCHMM is a novel profiling tool for identifying
#' differentially methylated CpG sites using Hidden Markov Model in bisulfite
#' sequencing data.
#' @aliases DMCHMM
#' @section \code{DMCHMM} methods:
#' \code{\link{cBSData}},
#' \code{\link{cBSDMCs}},
#' \code{\link{methHMEM}},
#' \code{\link{methHMMCMC}},
#' \code{\link{findDMCs}},
#' \code{\link{qqDMCs}},
#' \code{\link{manhattanDMCs}},
#' \code{\link{readBismark}},
#' \code{\link{writeBED}}.
#' @section \code{DMCHMM} objects:
#' \code{\link{BSData-class}},
#' \code{\link{BSDMCs-class}}
#'
#' @docType package
#' @name DMCHMM-package
NULL
